//+------------------------------------------------------------------+
//| Average 3.0 (using Nyquist criterion)                   NMA v1.2 |
//|                                                    brax64/mladen |
//|                                                 www.forx-tsd.com | 
//|Original idea by Dr. Manfred G Duerschner                         |
//|http://www.vtad.de/node/1441 (in German)                          |
//+------------------------------------------------------------------+

#property copyright "brax64/mladen"
#property link      "www.forx-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern int    NMA_Length        = 100;
extern string note              = "NMA_Length must be at least twice of NMA_Sample_Length";
extern int    NMA_Sample_Length = 25;
extern int    MA_Method         = MODE_LWMA;
extern int    MA_Price          = PRICE_TYPICAL;

double nma[];
double nmada[];
double nmadb[];
double nma_s[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(5);
      string label = "NMA (" + NMA_Length + "," +  NMA_Sample_Length + ")";
      SetIndexBuffer(0,nma);   SetIndexLabel(0,label);
      SetIndexBuffer(1,nmada); SetIndexLabel(1,label);
      SetIndexBuffer(2,nmadb); SetIndexLabel(2,label);
      SetIndexBuffer(3,nma_s);
      SetIndexBuffer(4,slope);
   IndicatorShortName("NMA");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int start()
{
   int i,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (slope[limit]==-1) CleanPoint(limit,nmada,nmadb);

      double Lambda = NMA_Length / NMA_Sample_Length;
      if(Lambda < 2.0)
      {
         Lambda = 2.0;
         NMA_Sample_Length = NMA_Length / 2.0;
      }
      double Alpha  = Lambda * (NMA_Length - 1.0) / (NMA_Length - Lambda);

      for (i = limit; i >= 0; i--)  nma_s[i] = iMA(NULL, 0, NMA_Length, 0, MA_Method, MA_Price, i);
      for (i = limit; i >= 0; i--)
      {   
         double Gamma     = iMAOnArray(nma_s,0,NMA_Sample_Length,0,MA_Method,i);
                nma[i]   = (Alpha+1.0)*nma_s[i] - Alpha*Gamma;
                slope[i] = slope[i+1];
                  if (nma[i]>nma[i+1]) slope[i] =  1; 
                  if (nma[i]<nma[i+1]) slope[i] = -1; 
                  if (slope[i]==-1) PlotPoint(i,nmada,nmadb,nma);
      }
      return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}